diff --git a/libavformat/Makefile b/libavformat/Makefile
index f84becd30a..cd3e9163f5 100644
--- a/libavformat/Makefile
+++ b/libavformat/Makefile
@@ -198,6 +198,7 @@ OBJS-$(CONFIG_FRAMEHASH_MUXER)           += hashenc.o framehash.o
 OBJS-$(CONFIG_FRAMEMD5_MUXER)            += hashenc.o framehash.o
 OBJS-$(CONFIG_FRM_DEMUXER)               += frmdec.o
 OBJS-$(CONFIG_FSB_DEMUXER)               += fsb.o
+OBJS-$(CONFIG_FWSE_DEMUXER)              += fwse.o
 OBJS-$(CONFIG_GIF_MUXER)                 += gif.o
 OBJS-$(CONFIG_GIF_DEMUXER)               += gifdec.o
 OBJS-$(CONFIG_GSM_DEMUXER)               += gsmdec.o
diff --git a/libavformat/allformats.c b/libavformat/allformats.c
index 08012ea208..d275c1017b 100644
--- a/libavformat/allformats.c
+++ b/libavformat/allformats.c
@@ -156,6 +156,7 @@ extern AVOutputFormat ff_framehash_muxer;
 extern AVOutputFormat ff_framemd5_muxer;
 extern AVInputFormat  ff_frm_demuxer;
 extern AVInputFormat  ff_fsb_demuxer;
+extern AVInputFormat  ff_fwse_demuxer;
 extern AVInputFormat  ff_g722_demuxer;
 extern AVOutputFormat ff_g722_muxer;
 extern AVInputFormat  ff_g723_1_demuxer;
diff --git a/libavformat/fwse.c b/libavformat/fwse.c
new file mode 100644
index 0000000000..76ed6b0c23
--- /dev/null
+++ b/libavformat/fwse.c
@@ -0,0 +1,88 @@
+/*
+ * FWSE demuxer
+ * Copyright (c) 2020 Paul B Mahol
+ *
+ * This file is part of FFmpeg.
+ *
+ * FFmpeg is free software; you can redistribute it and/or
+ * modify it under the terms of the GNU Lesser General Public
+ * License as published by the Free Software Foundation; either
+ * version 2.1 of the License, or (at your option) any later version.
+ *
+ * FFmpeg is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+ * Lesser General Public License for more details.
+ *
+ * You should have received a copy of the GNU Lesser General Public
+ * License along with FFmpeg; if not, write to the Free Software
+ * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
+ */
+
+#include "libavutil/intreadwrite.h"
+#include "libavcodec/internal.h"
+#include "avformat.h"
+#include "internal.h"
+#include "pcm.h"
+
+typedef struct FWSEDemuxContext {
+    unsigned dsp_int_type;
+    unsigned interleave_size;
+} FWSEDemuxContext;
+
+static int fwse_probe(const AVProbeData *p)
+{
+    if (AV_RL32(p->buf) != MKTAG('F','W','S','E'))
+        return 0;
+    if (AV_RL32(p->buf+4) != 2 && AV_RL32(p->buf+4) != 3)
+        return 0;
+
+    return AVPROBE_SCORE_MAX / 3 * 2;
+}
+
+static int fwse_read_header(AVFormatContext *s)
+{
+    FWSEDemuxContext *c = s->priv_data;
+    unsigned start_offset, version;
+    AVStream *st;
+
+    avio_skip(s->pb, 4);
+    version = avio_rl32(s->pb);
+    if (version != 1 && version != 2)
+        return AVERROR_INVALIDDATA;
+    avio_skip(s->pb, 4);
+    start_offset = avio_rl32(s->pb);
+
+    st = avformat_new_stream(s, NULL);
+    if (!st)
+        return AVERROR(ENOMEM);
+
+    st->codecpar->codec_type  = AVMEDIA_TYPE_AUDIO;
+    st->codecpar->codec_id    = AV_CODEC_ID_ADPCM_IMA_MTF;
+    st->codecpar->format      = AV_SAMPLE_FMT_S16;
+    st->codecpar->channels    = avio_rl32(s->pb);
+    if (st->codecpar->channels != 1 && st->codecpar->channels != 2)
+        return AVERROR_INVALIDDATA;
+    if (st->codecpar->channels == 1)
+        st->codecpar->channel_layout = AV_CH_LAYOUT_MONO;
+    else if (st->codecpar->channels == 2)
+        st->codecpar->channel_layout = AV_CH_LAYOUT_STEREO;
+    st->duration = avio_rl32(s->pb);
+    st->codecpar->sample_rate = avio_rl32(s->pb);
+    st->codecpar->block_align = 1;
+    avio_skip(s->pb, start_offset - avio_tell(s->pb));
+
+    avpriv_set_pts_info(st, 64, 1, st->codecpar->sample_rate);
+
+    return 0;
+}
+
+AVInputFormat ff_fwse_demuxer = {
+    .name           = "fwse",
+    .long_name      = NULL_IF_CONFIG_SMALL("Capcom's MT Framework sound"),
+    .priv_data_size = sizeof(FWSEDemuxContext),
+    .read_probe     = fwse_probe,
+    .read_header    = fwse_read_header,
+    .read_packet    = ff_pcm_read_packet,
+    .extensions     = "fwse",
+};