diff --git a/libavformat/Makefile b/libavformat/Makefile
index 27615cd746..5196f998ed 100644
--- a/libavformat/Makefile
+++ b/libavformat/Makefile
@@ -224,6 +224,7 @@ OBJS-$(CONFIG_H263_MUXER)                += rawenc.o
 OBJS-$(CONFIG_H264_DEMUXER)              += h264dec.o rawdec.o
 OBJS-$(CONFIG_H264_MUXER)                += rawenc.o
 OBJS-$(CONFIG_HASH_MUXER)                += hashenc.o
+OBJS-$(CONFIG_HCA_DEMUXER)               += hca.o
 OBJS-$(CONFIG_HCOM_DEMUXER)              += hcom.o pcm.o
 OBJS-$(CONFIG_HDS_MUXER)                 += hdsenc.o
 OBJS-$(CONFIG_HEVC_DEMUXER)              += hevcdec.o rawdec.o
diff --git a/libavformat/allformats.c b/libavformat/allformats.c
index af10def88b..39d2c352f5 100644
--- a/libavformat/allformats.c
+++ b/libavformat/allformats.c
@@ -182,6 +182,7 @@ extern AVOutputFormat ff_h263_muxer;
 extern AVInputFormat  ff_h264_demuxer;
 extern AVOutputFormat ff_h264_muxer;
 extern AVOutputFormat ff_hash_muxer;
+extern AVInputFormat  ff_hca_demuxer;
 extern AVInputFormat  ff_hcom_demuxer;
 extern AVOutputFormat ff_hds_muxer;
 extern AVInputFormat  ff_hevc_demuxer;
diff --git a/libavformat/hca.c b/libavformat/hca.c
new file mode 100644
index 0000000000..000833f55d
--- /dev/null
+++ b/libavformat/hca.c
@@ -0,0 +1,144 @@
+/*
+ * HCA demuxer
+ * Copyright (c) 2016 Paul B Mahol
+ *
+ * This file is part of FFmpeg.
+ *
+ * FFmpeg is free software; you can redistribute it and/or
+ * modify it under the terms of the GNU Lesser General Public
+ * License as published by the Free Software Foundation; either
+ * version 2.1 of the License, or (at your option) any later version.
+ *
+ * FFmpeg is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+ * Lesser General Public License for more details.
+ *
+ * You should have received a copy of the GNU Lesser General Public
+ * License along with FFmpeg; if not, write to the Free Software
+ * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
+ */
+
+#include "libavutil/intreadwrite.h"
+#include "avformat.h"
+#include "internal.h"
+
+static int hca_probe(const AVProbeData *p)
+{
+    if (AV_RL32(p->buf) != MKTAG('H', 'C', 'A', 0))
+        return 0;
+
+    return AVPROBE_SCORE_MAX / 3;
+}
+
+static int hca_read_header(AVFormatContext *s)
+{
+    AVCodecParameters *par;
+    AVIOContext *pb = s->pb;
+    AVStream *st;
+    uint32_t chunk;
+    uint16_t version;
+    uint32_t block_count;
+    uint16_t block_size;
+    int      ath_type;
+
+    avio_skip(pb, 4);
+    version = avio_rb16(pb);
+    ath_type = version < 0x200 ? 1 : 0;
+    s->internal->data_offset = avio_rb16(pb);
+
+    if (avio_rl32(pb) != MKTAG('f', 'm', 't', 0))
+        return AVERROR_INVALIDDATA;
+
+    st = avformat_new_stream(s, NULL);
+    if (!st)
+        return AVERROR(ENOMEM);
+
+    par              = st->codecpar;
+    par->codec_type  = AVMEDIA_TYPE_AUDIO;
+    par->codec_id    = AV_CODEC_ID_HCA;
+    par->codec_tag   = 0;
+    par->channels    = avio_r8(pb);
+    par->sample_rate = avio_rb24(pb);
+    block_count      = avio_rb32(pb);
+    avio_skip(pb, 4);
+    if (ff_alloc_extradata(par, 12) < 0)
+        return AVERROR(ENOMEM);
+    memset(par->extradata, 0, 12);
+
+    chunk = avio_rl32(pb);
+    if (chunk == MKTAG('c', 'o', 'm', 'p')) {
+        block_size = avio_rb16(pb);
+        avio_read(pb, par->extradata, 8);
+        avio_skip(pb, 2);
+    } else if (chunk == MKTAG('d', 'e', 'c', 0)) {
+        int count1, count2, count3, enable;
+
+        block_size = avio_rb16(pb);
+        par->extradata[0] = avio_r8(pb);
+        par->extradata[1] = avio_r8(pb);
+        count1 = avio_r8(pb);
+        count2 = avio_r8(pb);
+        count3 = avio_r8(pb);
+        enable = avio_r8(pb);
+        par->extradata[2] = FFMAX(count3 >> 4, 1);
+        par->extradata[3] = count3 & 0xf;
+        par->extradata[4] = count1 + 1;
+        par->extradata[5] = (enable ? count2 : count1) + 1;
+        par->extradata[6] = par->extradata[4]  - par->extradata[5];
+    } else {
+        return AVERROR_INVALIDDATA;
+    }
+
+    if (block_size < 8) {
+        return AVERROR_INVALIDDATA;
+    }
+    par->block_align = block_size;
+    st->duration = 1024 * block_count;
+
+    while (avio_tell(pb) < s->internal->data_offset && !avio_feof(pb)) {
+        chunk = avio_rl32(pb) & 0x7f7f7f7f;
+
+        if (chunk == MKTAG('v', 'b', 'r', 0)) {
+            avio_skip(pb, 4);
+        } else if (chunk == MKTAG('a', 't', 'h', 0)) {
+            ath_type = avio_rb16(pb);
+        } else if (chunk == MKTAG('l', 'o', 'o', 'p')) {
+            avio_skip(pb, 12);
+        } else if (chunk == MKTAG('c', 'i', 'p', 'h')) {
+            par->extradata[8] = avio_r8(pb);
+            par->extradata[9] = avio_r8(pb);
+        } else if (chunk == MKTAG('r', 'v', 'a', 0)) {
+            avio_skip(pb, 4);
+        } else if (chunk == MKTAG('c', 'o', 'm', 'm')) {
+            avio_skip(pb, avio_r8(pb));
+        } else if (chunk == MKTAG('p', 'a', 'd', 0)) {
+            break;
+        }
+    }
+
+    avio_seek(pb, s->internal->data_offset, SEEK_SET);
+    avpriv_set_pts_info(st, 64, 1, par->sample_rate);
+
+    return 0;
+}
+
+static int hca_read_packet(AVFormatContext *s, AVPacket *pkt)
+{
+    AVCodecContext *codec = s->streams[0]->codec;
+    int ret;
+
+    ret = av_get_packet(s->pb, pkt, codec->block_align);
+    pkt->duration = 1024;
+    return ret;
+}
+
+AVInputFormat ff_hca_demuxer = {
+    .name           = "hca",
+    .long_name      = NULL_IF_CONFIG_SMALL("CRI HCA"),
+    .read_probe     = hca_probe,
+    .read_header    = hca_read_header,
+    .read_packet    = hca_read_packet,
+    .extensions     = "hca",
+    .flags          = AVFMT_GENERIC_INDEX,
+};