diff --git a/libavformat/Makefile b/libavformat/Makefile
index 26af859a28..b433a6029c 100644
--- a/libavformat/Makefile
+++ b/libavformat/Makefile
@@ -120,6 +120,7 @@ OBJS-$(CONFIG_AVR_DEMUXER)               += avr.o pcm.o
 OBJS-$(CONFIG_AVS_DEMUXER)               += avs.o voc_packet.o vocdec.o voc.o
 OBJS-$(CONFIG_AVS2_DEMUXER)              += davs2.o rawdec.o
 OBJS-$(CONFIG_AVS2_MUXER)                += rawenc.o
+OBJS-$(CONFIG_AVS3_DEMUXER)              += avs3dec.o rawdec.o
 OBJS-$(CONFIG_BETHSOFTVID_DEMUXER)       += bethsoftvid.o
 OBJS-$(CONFIG_BFI_DEMUXER)               += bfi.o
 OBJS-$(CONFIG_BINK_DEMUXER)              += bink.o
diff --git a/libavformat/allformats.c b/libavformat/allformats.c
index 97fd06debb..2d768b8c88 100644
--- a/libavformat/allformats.c
+++ b/libavformat/allformats.c
@@ -82,6 +82,7 @@ extern AVInputFormat  ff_avr_demuxer;
 extern AVInputFormat  ff_avs_demuxer;
 extern AVInputFormat  ff_avs2_demuxer;
 extern AVOutputFormat ff_avs2_muxer;
+extern AVInputFormat  ff_avs3_demuxer;
 extern AVInputFormat  ff_bethsoftvid_demuxer;
 extern AVInputFormat  ff_bfi_demuxer;
 extern AVInputFormat  ff_bintext_demuxer;
diff --git a/libavformat/avs3dec.c b/libavformat/avs3dec.c
new file mode 100644
index 0000000000..955114dc42
--- /dev/null
+++ b/libavformat/avs3dec.c
@@ -0,0 +1,75 @@
+/*
+ * RAW AVS3-P2/IEEE1857.10 video demuxer
+ * Copyright (c) 2020 Zhenyu Wang <wangzhenyu@pkusz.edu.cn>
+ *                    Bingjie Han <hanbj@pkusz.edu.cn>
+ *                    Huiwen Ren  <hwrenx@gmail.com>
+ *
+ * This file is part of FFmpeg.
+ *
+ * FFmpeg is free software; you can redistribute it and/or
+ * modify it under the terms of the GNU Lesser General Public
+ * License as published by the Free Software Foundation; either
+ * version 2.1 of the License, or (at your option) any later version.
+ *
+ * FFmpeg is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+ * Lesser General Public License for more details.
+ *
+ * You should have received a copy of the GNU Lesser General Public
+ * License along with FFmpeg; if not, write to the Free Software
+ * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
+ */
+
+#include "libavcodec/internal.h"
+#include "avformat.h"
+#include "rawdec.h"
+
+#define AVS3_SEQ_START_CODE       0x000001b0
+#define AVS3_PIC_I_START_CODE     0x000001b3
+#define AVS3_UNDEF_START_CODE     0x000001b4
+#define AVS3_PIC_PB_START_CODE    0x000001b6
+#define AVS3_VIDEO_EDIT_CODE      0x000001b7
+#define AVS3_PROFILE_JIZHUN       0x20
+#define AVS3_PROFILE_JIZHUN10     0x22
+
+static int avs3video_probe(const AVProbeData *p)
+{
+    uint32_t code= -1;
+    int pic=0, seq=0, slice_pos = 0;
+    const uint8_t *ptr = p->buf, *end = p->buf + p->buf_size;
+    int ret = 0;
+
+    while (ptr < end) {
+        ptr = avpriv_find_start_code(ptr, end, &code);
+        if ((code & 0xffffff00) == 0x100) {
+            if (code < AVS3_SEQ_START_CODE) {
+                /* slices have to be consecutive */
+                if (code < slice_pos)
+                    return 0;
+                slice_pos = code;
+            } else {
+                slice_pos = 0;
+            }
+            if (code == AVS3_SEQ_START_CODE) {
+                seq++;
+                /* check for the only currently supported profile */
+                if (*ptr != AVS3_PROFILE_JIZHUN && *ptr != AVS3_PROFILE_JIZHUN10)
+                    return 0;
+            } else if ((code == AVS3_PIC_I_START_CODE) ||
+                       (code == AVS3_PIC_PB_START_CODE)) {
+                pic++;
+            } else if ((code == AVS3_UNDEF_START_CODE) ||
+                       (code >  AVS3_VIDEO_EDIT_CODE)) {
+                return 0;
+            }
+        }
+    }
+    if (seq && pic && av_match_ext(p->filename, "avs3")) {
+        ret = AVPROBE_SCORE_MAX;
+    }
+    return ret;
+}
+
+FF_DEF_RAWVIDEO_DEMUXER(avs3, "raw AVS3-P2/IEEE1857.10", avs3video_probe, "avs3", AV_CODEC_ID_AVS3)
+